Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_output_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_output_mod.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_output_mod.F90	(revision 2428)
@@ -8,4 +8,5 @@
   USE MOD_COSP_CONSTANTS
   USE MOD_COSP_TYPES
+  use MOD_COSP_Modis_Simulator, only : cosp_modis
 
 ! cosp_output_mod
@@ -15,7 +16,7 @@
       INTEGER, DIMENSION(3), SAVE  :: cosp_nidfiles
 !$OMP THREADPRIVATE(cosp_outfilekeys, cosp_nidfiles)
-      INTEGER, DIMENSION(3), SAVE  :: nhoricosp, nvert, nvertmcosp, nvertcol, nvertisccp, nvertp
+      INTEGER, DIMENSION(3), SAVE  :: nhoricosp,nvert,nvertmcosp,nvertcol,nvertisccp,nvertp,nverttemp,nvertmisr
       REAL, DIMENSION(3), SAVE                :: zoutm_cosp
-!$OMP THREADPRIVATE(nhoricosp, nvert, nvertmcosp, nvertcol, nvertisccp, nvertp, zoutm_cosp)
+!$OMP THREADPRIVATE(nhoricosp, nvert, nvertmcosp, nvertcol, nvertisccp, nvertp, zoutm_cosp, nverttemp, nvertmisr)
       REAL, SAVE                   :: zdtimemoy_cosp
 !$OMP THREADPRIVATE(zdtimemoy_cosp) 
@@ -33,15 +34,16 @@
      CHARACTER(len=20),DIMENSION(3)  :: cosp_typeecrit        !!! Operation (ave, inst, ...)
   END TYPE ctrl_outcosp
+
 ! CALIPSO vars
   TYPE(ctrl_outcosp), SAVE :: o_cllcalipso = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
-         "cllcalipso", "Lidar Low-level Cloud Fraction", "1", (/ ('', i=1, 3) /))                                   
+         "cllcalipso", "Lidar Low-level Cloud Fraction", "%", (/ ('', i=1, 3) /))                                   
   TYPE(ctrl_outcosp), SAVE :: o_clmcalipso = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
-         "clmcalipso", "Lidar Mid-level Cloud Fraction", "1", (/ ('', i=1, 3) /))
+         "clmcalipso", "Lidar Mid-level Cloud Fraction", "%", (/ ('', i=1, 3) /))
   TYPE(ctrl_outcosp), SAVE :: o_clhcalipso = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
-         "clhcalipso", "Lidar Hight-level Cloud Fraction", "1", (/ ('', i=1, 3) /))
+         "clhcalipso", "Lidar Hight-level Cloud Fraction", "%", (/ ('', i=1, 3) /))
   TYPE(ctrl_outcosp), SAVE :: o_cltcalipso = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
-         "cltcalipso", "Lidar Total Cloud Fraction", "1", (/ ('', i=1, 3) /)) 
+         "cltcalipso", "Lidar Total Cloud Fraction", "%", (/ ('', i=1, 3) /)) 
   TYPE(ctrl_outcosp), SAVE :: o_clcalipso = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
-         "clcalipso", "Lidar Cloud Fraction (532 nm)", "1", (/ ('', i=1, 3) /))
+         "clcalipso", "Lidar Cloud Fraction (532 nm)", "%", (/ ('', i=1, 3) /))
   TYPE(ctrl_outcosp), SAVE :: o_cfad_lidarsr532 = ctrl_outcosp((/ .FALSE., .FALSE., .FALSE. /), &
          "cfad_lidarsr532", "Lidar Scattering Ratio CFAD (532 nm)", "1", (/ ('', i=1, 3) /))   
@@ -56,4 +58,54 @@
   TYPE(ctrl_outcosp), SAVE :: o_beta_mol532 = ctrl_outcosp((/ .FALSE., .FALSE., .FALSE. /), &
          "beta_mol532", "Lidar Molecular Backscatter (532 nm)","m-1 sr-1", (/ ('', i=1, 3) /))
+!! AI  11 2015
+  TYPE(ctrl_outcosp), SAVE :: o_cllcalipsoice = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), & 
+         "cllcalipsoice", "CALIPSO Ice-Phase Low Level Cloud Fraction", "%", (/ ('', i=1, 3) /))  
+  TYPE(ctrl_outcosp), SAVE :: o_cllcalipsoliq = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cllcalipsoliq", "CALIPSO Liq-Phase Low Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clmcalipsoice = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clmcalipsoice", "CALIPSO Ice-Phase Mid Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clmcalipsoliq = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clmcalipsoliq", "CALIPSO Liq-Phase Mid Level Cloud Fraction", "%", (/ ('', i=1, 3) /))	 	 
+  TYPE(ctrl_outcosp), SAVE :: o_clhcalipsoice = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), & 
+         "clhcalipsoice", "CALIPSO Ice-Phase High Level Cloud Fraction", "%", (/ ('', i=1, 3) /))  
+  TYPE(ctrl_outcosp), SAVE :: o_clhcalipsoliq = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clhcalipsoliq", "CALIPSO Liq-Phase High Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_cltcalipsoice = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cltcalipsoice", "CALIPSO Ice-Phase Tot Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_cltcalipsoliq = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cltcalipsoliq", "CALIPSO Liq-Phase Tot Level Cloud Fraction", "%", (/ ('', i=1, 3) /))	 	 
+  TYPE(ctrl_outcosp), SAVE :: o_cllcalipsoun = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), & 
+         "cllcalipsoun", "CALIPSO Undefined-Phase Low Level Cloud Fraction", "%", (/ ('', i=1, 3) /))  
+  TYPE(ctrl_outcosp), SAVE :: o_clmcalipsoun = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clmcalipsoun", "CALIPSO Undefined-Phase Mid Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clhcalipsoun = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clhcalipsoun", "CALIPSO Undefined-Phase High Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_cltcalipsoun = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cltcalipsoun", "CALIPSO Undefined-Phase Tot Level Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsoice = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsoice", "Lidar Ice-Phase Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsoliq = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsoliq", "Lidar Liq-Phase Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsoun = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsoun", "Lidar Undef-Phase Cloud Fraction", "%", (/ ('', i=1, 3) /))	 
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsotmpice = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsotmpice", "Lidar Ice-Phase Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsotmpliq = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsotmpliq", "Lidar Liq-Phase Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsotmpun = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsotmpun", "Lidar Undef-Phase Cloud Fraction", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipsotmp = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipsotmp", "Lidar Cloud Fraction", "%", (/ ('', i=1, 3) /))
+
+! Radar Cloudsat
+  TYPE(ctrl_outcosp), SAVE :: o_cfadDbze94 = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cfadDbze94", "CloudSat Radar Reflectivity CFAD", "%", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_dbze94 = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "dbze94", "CloudSat Radar Reflectivity", "%", (/ ('', i=1, 3) /))
+
+! Calipso + Cloudsat
+  TYPE(ctrl_outcosp), SAVE :: o_clcalipso2 = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clcalipso2", "CALIPSO Cloud Fraction Undetected by CloudSat", "1", (/ ('', i=1, 3) /))
+
 ! ISCCP vars
   TYPE(ctrl_outcosp), SAVE :: o_sunlit = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
@@ -80,4 +132,54 @@
            by the ISCCP Simulator","K", (/ ('', i=1, 3) /))
 
+! MISR simulator
+  TYPE(ctrl_outcosp), SAVE :: o_clMISR = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clMISR", "Cloud Fraction as Calculated by the MISR Simulator","1", (/ ('', i=1, 3) /))
+
+! MODIS simulator
+  TYPE(ctrl_outcosp), SAVE :: o_cllmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cllmodis", "MODIS Low-level Cloud Fraction", "1", (/ ('', i=1, 3) /))                                   
+  TYPE(ctrl_outcosp), SAVE :: o_clmmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clmmodis", "MODIS Mid-level Cloud Fraction", "1", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_clhmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clhmodis", "MODIS Hight-level Cloud Fraction", "1", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_cltmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "cltmodis", "MODIS Total Cloud Fraction", "1", (/ ('', i=1, 3) /)) 
+  TYPE(ctrl_outcosp), SAVE :: o_clwmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clwmodis", "MODIS Cloud Fraction water mean", "1", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_climodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "climodis", "MODIS Cloud Fraction ice mean", "1", (/ ('', i=1, 3) /))	
+  TYPE(ctrl_outcosp), SAVE :: o_tautmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tautmodis", "MODIS Optical_Thickness_Total_Mean", "1", (/ ('', i=1, 3) /))                                   
+  TYPE(ctrl_outcosp), SAVE :: o_tauwmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tauwmodis", "MODIS Optical_Thickness_Water_Mean", "1", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_tauimodis= ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tauimodis", "MODIS Optical_Thickness_Ice_Mean", "1", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_tautlogmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tautlogmodis", "MODIS Optical_Thickness_Total_logMean", "1", (/ ('', i=1, 3) /))                                   
+  TYPE(ctrl_outcosp), SAVE :: o_tauwlogmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tauwlogmodis", "MODIS Optical_Thickness_Water_logMean", "1", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_tauilogmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tauilogmodis", "MODIS Optical_Thickness_Ice_logMean", "1", (/ ('', i=1, 3) /))	 
+  TYPE(ctrl_outcosp), SAVE :: o_reffclwmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "reffclwmodis", "Modis Cloud_Particle_Size_Water_Mean", "m", (/ ('', i=1, 3) /))	 	 
+  TYPE(ctrl_outcosp), SAVE :: o_reffclimodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "reffclimodis", "Modis Cloud_Particle_Size_Ice_Mean", "m", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_pctmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "pctmodis", "Modis Cloud_Top_Pressure_Total_Mean", "Pa", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_lwpmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "lwpmodis", "Modis Liquid_Water_Path_Mean", "kg m-2", (/ ('', i=1, 3) /))
+  TYPE(ctrl_outcosp), SAVE :: o_iwpmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "iwpmodis", "Modis Ice_Water_Path_Mean", "kg m-2", (/ ('', i=1, 3) /))	 
+  TYPE(ctrl_outcosp), SAVE :: o_clmodis = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "clmodis", "MODIS Cloud Area Fraction", "%", (/ ('', i=1, 3) /))
+
+! Rttovs simulator
+  TYPE(ctrl_outcosp), SAVE :: o_tbrttov = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "tbrttov", "Rttovs Cloud Area Fraction", "%", (/ ('', i=1, 3) /))
+
+! Scops and others
+  TYPE(ctrl_outcosp), SAVE :: o_fracout = ctrl_outcosp((/ .TRUE., .TRUE., .TRUE. /), &
+         "fracout", "Subcolumn output from SCOPS", "%", (/ ('', i=1, 3) /))	 
+
   LOGICAL, SAVE :: cosp_varsdefined = .FALSE. ! ug PAS THREADPRIVATE ET C'EST NORMAL
   REAL, SAVE  :: Cosp_fill_value
@@ -181,13 +283,8 @@
           Cosp_fill_value=0.
          print*,'Cosp_fill_value=',Cosp_fill_value
-    ! ug R\'eglage du calendrier xios
-    !Temps julian => an, mois, jour, heure
-!    CALL ju2ymds(zjulian, x_an, x_mois, x_jour, x_heure)
-!    CALL ju2ymds(zjulian_start, ini_an, ini_mois, ini_jour, ini_heure)
-!    CALL wxios_set_cal(dtime, calend, x_an, x_mois, x_jour, x_heure, ini_an, &
-!                       ini_mois, ini_jour, ini_heure )
-       ! ug dï¿½claration des axes verticaux de chaque fichier:
 !    if (use_vgrid) then
+!      print*,'vgrid%Nlvgrid, vgrid%z = ',vgrid%Nlvgrid, vgrid%z
         CALL wxios_add_vaxis("height", vgrid%Nlvgrid, vgrid%z)
+     print*,'wxios_add_vaxis '
 !    else
 !         WRITE(lunout,*) 'wxios_add_vaxis "presnivs", vgrid%Nlvgrid ',vgrid%Nlvgrid
@@ -202,4 +299,8 @@
     WRITE(lunout,*) 'wxios_add_vaxis column ',Ncolumns
     CALL wxios_add_vaxis("column", Ncolumns, column_ax)
+
+! AI nov 2015
+   CALL wxios_add_vaxis("temp", LIDAR_NTEMP, LIDAR_PHASE_TEMP)
+   CALL wxios_add_vaxis("cth16", MISR_N_CTH, MISR_CTH)
 #endif
    
@@ -212,6 +313,6 @@
            CALL histbeg_phy_all(cosp_outfilenames(iff),itau_phy,zjulian,&
              dtime,nhoricosp(iff),cosp_nidfiles(iff))
-           print*,'histbeg_phy nhoricosp(iff),cosp_nidfiles(iff)', &
-                    nhoricosp(iff),cosp_nidfiles(iff)
+!           print*,'histbeg_phy nhoricosp(iff),cosp_nidfiles(iff)', &
+!                    nhoricosp(iff),cosp_nidfiles(iff)
 
 #ifdef CPP_XIOS
@@ -240,4 +341,6 @@
       CALL histvert(cosp_nidfiles(iff),"column","column","count",Ncolumns,column_ax(1:Ncolumns),nvertcol(iff))
 
+      CALL histvert(cosp_nidfiles(iff),"temp","temperature","C",LIDAR_NTEMP,LIDAR_PHASE_TEMP,nverttemp(iff))                                       
+      CALL histvert(cosp_nidfiles(iff),"cth16","altitude","m",MISR_N_CTH,MISR_CTH,nvertmisr(iff))                                                                                                  
 !!! Valeur indefinie en cas IOIPSL
      Cosp_fill_value=0.
Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_output_write_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_output_write_mod.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_output_write_mod.F90	(revision 2428)
@@ -18,5 +18,6 @@
 
   SUBROUTINE cosp_output_write(Nlevlmdz, Npoints, Ncolumns, itap, dtime, freq_COSP, &
-                               cfg, gbx, vgrid, sglidar, stlidar, isccp)
+                               cfg, gbx, vgrid, sglidar, sgradar, stlidar, stradar, &
+                               isccp, misr, modis)
 
     USE ioipsl
@@ -35,6 +36,10 @@
   type(cosp_gridbox)    :: gbx     ! Gridbox information. Input for COSP
   type(cosp_sglidar)    :: sglidar ! Output from lidar simulator
+  type(cosp_sgradar)    :: sgradar ! Output from radar simulator
   type(cosp_isccp)      :: isccp   ! Output from ISCCP simulator
   type(cosp_lidarstats) :: stlidar ! Summary statistics from lidar simulator
+  type(cosp_radarstats) :: stradar
+  type(cosp_misr)       :: misr    ! Output from MISR
+  type(cosp_modis)      :: modis   ! Outputs from Modis
   type(cosp_vgrid)      :: vgrid   ! Information on vertical grid of stats
 
@@ -126,4 +131,13 @@
    enddo
 
+! AI 11 / 2015
+
+   where(stlidar%parasolrefl == R_UNDEF) stlidar%parasolrefl = 0.0
+   where(stlidar%lidarcldtmp == R_UNDEF) stlidar%lidarcldtmp = 0.0
+   where(stlidar%cldlayerphase == R_UNDEF) stlidar%cldlayerphase = 0.0
+   where(stlidar%lidarcldphase == R_UNDEF) stlidar%lidarcldphase = 0.0
+   where(stlidar%lidarcldtmp == R_UNDEF) stlidar%lidarcldtmp = 0.0
+   
+
    print*,'Appel histwrite2d_cosp'
    CALL histwrite2d_cosp(o_cllcalipso,stlidar%cldlayer(:,1))
@@ -132,4 +146,26 @@
    CALL histwrite2d_cosp(o_cltcalipso,stlidar%cldlayer(:,4))
    CALL histwrite3d_cosp(o_clcalipso,stlidar%lidarcld,nvert)
+   CALL histwrite3d_cosp(o_clcalipsotmp,stlidar%lidarcldtmp(:,:,1),nverttemp)
+
+   CALL histwrite2d_cosp(o_cllcalipsoice,stlidar%cldlayerphase(:,1,1))
+   CALL histwrite2d_cosp(o_clhcalipsoice,stlidar%cldlayerphase(:,3,1))
+   CALL histwrite2d_cosp(o_clmcalipsoice,stlidar%cldlayerphase(:,2,1))
+   CALL histwrite2d_cosp(o_cltcalipsoice,stlidar%cldlayerphase(:,4,1))
+   CALL histwrite3d_cosp(o_clcalipsoice,stlidar%lidarcldphase(:,:,1),nvert)
+   CALL histwrite3d_cosp(o_clcalipsotmpice,stlidar%lidarcldtmp(:,:,2),nverttemp)
+
+   CALL histwrite2d_cosp(o_cllcalipsoliq,stlidar%cldlayerphase(:,1,2))
+   CALL histwrite2d_cosp(o_clhcalipsoliq,stlidar%cldlayerphase(:,3,2))
+   CALL histwrite2d_cosp(o_clmcalipsoliq,stlidar%cldlayerphase(:,2,2))
+   CALL histwrite2d_cosp(o_cltcalipsoliq,stlidar%cldlayerphase(:,4,2))
+   CALL histwrite3d_cosp(o_clcalipsoliq,stlidar%lidarcldphase(:,:,2),nvert)
+   CALL histwrite3d_cosp(o_clcalipsotmpliq,stlidar%lidarcldtmp(:,:,3),nverttemp)
+
+   CALL histwrite2d_cosp(o_cllcalipsoun,stlidar%cldlayerphase(:,1,3))
+   CALL histwrite2d_cosp(o_clhcalipsoun,stlidar%cldlayerphase(:,3,3))
+   CALL histwrite2d_cosp(o_clmcalipsoun,stlidar%cldlayerphase(:,2,3))
+   CALL histwrite2d_cosp(o_cltcalipsoun,stlidar%cldlayerphase(:,4,3))
+   CALL histwrite3d_cosp(o_clcalipsoice,stlidar%lidarcldphase(:,:,3),nvert)
+   CALL histwrite3d_cosp(o_clcalipsotmpun,stlidar%lidarcldtmp(:,:,4),nverttemp)
 
    do icl=1,SR_BINS
@@ -160,24 +196,39 @@
  endif !Lidar
 
+ if (cfg%Lradar_sim) then
+   do icl=1,Ncolumns
+      CALL histwrite3d_cosp(o_dbze94,sgradar%Ze_tot(:,icl,:),nvertmcosp,icl)
+   enddo
+   do icl=1,DBZE_BINS
+    CALL histwrite3d_cosp(o_cfadDbze94,stradar%cfad_ze(:,icl,:),nvert,icl)
+   enddo
+ endif
+
+ if (cfg%Llidar_sim .and. cfg%Lradar_sim) then
+   where(stradar%lidar_only_freq_cloud == R_UNDEF) &
+                           stradar%lidar_only_freq_cloud = 0.0
+   CALL histwrite3d_cosp(o_clcalipso2,stradar%lidar_only_freq_cloud,nvert)
+ endif
+
  if (cfg%Lisccp_sim) then
 
 ! Traitement des valeurs indefinies
    do ip = 1,Npoints
-    if(isccp%totalcldarea(ip).eq.-1.E+30)then
+    if(isccp%totalcldarea(ip).eq.R_UNDEF)then
       isccp%totalcldarea(ip)=Cosp_fill_value
     endif
-    if(isccp%meanptop(ip).eq.-1.E+30)then
+    if(isccp%meanptop(ip).eq.R_UNDEF)then
       isccp%meanptop(ip)=Cosp_fill_value
     endif
-    if(isccp%meantaucld(ip).eq.-1.E+30)then
+    if(isccp%meantaucld(ip).eq.R_UNDEF)then
       isccp%meantaucld(ip)=Cosp_fill_value
     endif
-    if(isccp%meanalbedocld(ip).eq.-1.E+30)then
+    if(isccp%meanalbedocld(ip).eq.R_UNDEF)then
       isccp%meanalbedocld(ip)=Cosp_fill_value
     endif
-    if(isccp%meantb(ip).eq.-1.E+30)then
+    if(isccp%meantb(ip).eq.R_UNDEF)then
       isccp%meantb(ip)=Cosp_fill_value
     endif
-    if(isccp%meantbclr(ip).eq.-1.E+30)then
+    if(isccp%meantbclr(ip).eq.R_UNDEF)then
       isccp%meantbclr(ip)=Cosp_fill_value
     endif
@@ -185,5 +236,5 @@
     do k=1,7
      do ii=1,7
-     if(isccp%fq_isccp(ip,ii,k).eq.-1.E+30)then
+     if(isccp%fq_isccp(ip,ii,k).eq.R_UNDEF)then
       isccp%fq_isccp(ip,ii,k)=Cosp_fill_value
      endif
@@ -192,5 +243,5 @@
 
     do ii=1,Ncolumns
-     if(isccp%boxtau(ip,ii).eq.-1.E+30)then
+     if(isccp%boxtau(ip,ii).eq.R_UNDEF)then
        isccp%boxtau(ip,ii)=Cosp_fill_value
      endif
@@ -198,5 +249,5 @@
 
     do ii=1,Ncolumns
-     if(isccp%boxptop(ip,ii).eq.-1.E+30)then
+     if(isccp%boxptop(ip,ii).eq.R_UNDEF)then
        isccp%boxptop(ip,ii)=Cosp_fill_value
      endif
@@ -217,4 +268,101 @@
    CALL histwrite2d_cosp(o_meantbclrisccp,isccp%meantbclr)
  endif ! Isccp
+
+! MISR simulator
+ if (cfg%Lmisr_sim) then
+   do ip=1,Npoints
+     do ii=1,7
+       do k=1,MISR_N_CTH
+        if(misr%fq_MISR(ip,ii,k).eq.R_UNDEF)then
+              misr%fq_MISR(ip,ii,k)=Cosp_fill_value
+        endif
+       enddo
+     enddo
+   enddo
+
+   do icl=1,7 
+      CALL histwrite3d_cosp(o_clMISR,misr%fq_MISR(:,icl,:),nvertmisr,icl)
+   enddo
+ endif
+
+! Modis simulator
+ if (cfg%Lmodis_sim) then
+
+  do ip=1,Npoints
+    if(modis%Cloud_Fraction_Low_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Fraction_Low_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Fraction_High_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Fraction_High_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Fraction_Mid_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Fraction_Mid_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Fraction_Total_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Fraction_Total_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Fraction_Water_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Fraction_Water_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Fraction_Ice_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Fraction_Ice_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Optical_Thickness_Total_Mean(ip).eq.R_UNDEF)then
+       modis%Optical_Thickness_Total_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Optical_Thickness_Water_Mean(ip).eq.R_UNDEF)then
+       modis%Optical_Thickness_Water_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Optical_Thickness_Ice_Mean(ip).eq.R_UNDEF)then
+       modis%Optical_Thickness_Ice_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Particle_Size_Water_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Particle_Size_Water_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Top_Pressure_Total_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Top_Pressure_Total_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Liquid_Water_Path_Mean(ip).eq.R_UNDEF)then
+       modis%Liquid_Water_Path_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Ice_Water_Path_Mean(ip).eq.R_UNDEF)then
+       modis%Ice_Water_Path_Mean(ip)=Cosp_fill_value
+    endif
+
+  enddo
+    
+   CALL histwrite2d_cosp(o_cllmodis,modis%Cloud_Fraction_Low_Mean)
+   CALL histwrite2d_cosp(o_clhmodis,modis%Cloud_Fraction_High_Mean)
+   CALL histwrite2d_cosp(o_clmmodis,modis%Cloud_Fraction_Mid_Mean)
+   CALL histwrite2d_cosp(o_cltmodis,modis%Cloud_Fraction_Total_Mean)
+   CALL histwrite2d_cosp(o_clwmodis,modis%Cloud_Fraction_Water_Mean)
+   CALL histwrite2d_cosp(o_climodis,modis%Cloud_Fraction_Ice_Mean)
+   CALL histwrite2d_cosp(o_tautmodis,modis%Optical_Thickness_Total_Mean)
+   CALL histwrite2d_cosp(o_tauwmodis,modis%Optical_Thickness_Water_Mean)
+   CALL histwrite2d_cosp(o_tauimodis,modis%Optical_Thickness_Ice_Mean)
+   CALL histwrite2d_cosp(o_tautlogmodis,modis%Optical_Thickness_Total_LogMean)  
+   CALL histwrite2d_cosp(o_tauwlogmodis,modis%Optical_Thickness_Water_LogMean)
+   CALL histwrite2d_cosp(o_tauilogmodis,modis%Optical_Thickness_Ice_LogMean)
+   CALL histwrite2d_cosp(o_reffclwmodis,modis%Cloud_Particle_Size_Water_Mean)
+   CALL histwrite2d_cosp(o_reffclimodis,modis%Cloud_Particle_Size_Ice_Mean)
+   CALL histwrite2d_cosp(o_pctmodis,modis%Cloud_Top_Pressure_Total_Mean)
+   CALL histwrite2d_cosp(o_lwpmodis,modis%Liquid_Water_Path_Mean)
+   CALL histwrite2d_cosp(o_iwpmodis,modis%Ice_Water_Path_Mean)
+
+   do ip=1,Npoints
+     do ii=1,7
+       do k=1,7
+       if(modis%Optical_Thickness_vs_Cloud_Top_Pressure(ip,ii,k).eq.R_UNDEF)then
+          modis%Optical_Thickness_vs_Cloud_Top_Pressure(ip,ii,k)=0.
+        endif
+       enddo
+     enddo
+    enddo 
+
+   do icl=1,7
+   CALL histwrite3d_cosp(o_clmodis, &
+     modis%Optical_Thickness_vs_Cloud_Top_Pressure(:,icl,:),nvertisccp,icl)           
+   enddo
+ endif
 
  IF(.NOT.cosp_varsdefined) THEN
@@ -362,4 +510,10 @@
           klevs=Ncolout
           nam_axvert="column"
+      ELSE IF (nvertsave.eq.nverttemp(iff)) THEN
+          klevs=LIDAR_NTEMP
+          nam_axvert="temp"
+      ELSE IF (nvertsave.eq.nvertmisr(iff)) THEN
+          klevs=MISR_N_CTH
+           nam_axvert="cth16"
       ELSE
            klevs=Nlevout
@@ -494,5 +648,5 @@
 #ifdef CPP_XIOS
       IF (ok_all_xml) THEN
-        if (prt_level >= 10) then
+        if (prt_level >= 1) then
               WRITE(lunout,*)'xios_send_field variable ',var%name
         endif
@@ -596,5 +750,5 @@
     IF (ok_all_xml) THEN
      CALL xios_send_field(nom, Field3d(:,:,1:nlev))
-     IF (prt_level >= 9) WRITE(lunout,*)'xios_send_field ',var%name
+     IF (prt_level >= 1) WRITE(lunout,*)'xios_send_field ',var%name
     ENDIF
 #endif
